#include<avr/io.h>
#include<util/delay.h>

#include <avr/interrupt.h>


#include <stdio.h>





#define LCD_DPRT PORTA
#define LCD_DDDR DDRA
#define LCD_DPIN PINA
#define LCD_CPRT PORTD	
#define LCD_CDDR DDRD
#define LCD_CPIN PIND
#define LCD_RS 0
#define LCD_RW 1
#define LCD_EN 3
////////////////////////////////////////////////////////////
unsigned long int freq;
unsigned int i=0 , dur;
float freqf1;
char display ;double freqf ;
char mystr[];
////////////////////////////////////////////////////////////
	ISR(TIMER1_OVF_vect)
	{
	i++; // count the number of overflows in one second
	}
///////////////////////////////////////////////////////////
	void lcdcommand( unsigned char cmnd)
	{	LCD_DPRT = cmnd ;
		LCD_CPRT &= ~ (1<<LCD_RS);
		LCD_CPRT &= ~ (1<<LCD_RW);
		LCD_CPRT |= (1<<LCD_EN);
		_delay_us(1);
		LCD_CPRT &= ~(1<<LCD_EN);
		_delay_us(100);
	}
///////////////////////////////////////////////////////////
	void lcddata ( unsigned char data)
	{
		LCD_DPRT = data ;
		LCD_CPRT |= (1<<LCD_RS);
		LCD_CPRT &= ~ (1<<LCD_RW);
		LCD_CPRT |= (1<<LCD_EN);
		_delay_us(1);
		LCD_CPRT &= ~ (1<<LCD_EN);
		_delay_us(100);
	}
/////////////////////////////////////////////////////////
	void lcd_init()
	{
		LCD_CPRT = 0xFF;
		LCD_DPRT = 0xFF;
		LCD_CPRT &= ~ (1<<LCD_EN);
		_delay_us(2000);
		lcdcommand(0x38);
		lcdcommand(0x0E);
		lcdcommand(0x01);
		_delay_us(2000);
		lcdcommand(0x06);
	}
////////////////////////////////////////////////////////
  	void lcd_gotoxy( unsigned char x,unsigned char y)
	{	unsigned char fca[]={0x80,0xC0,0x94,0xD4};
		lcdcommand(fca[y-1] + x-1);
		_delay_us(100);
	}
//////////////////////////////////////////////////////
	void lcdprint ( char * str )
	{	unsigned char a=0;
		while(str[a] !=0)
		{
		lcddata(str[a]);
		a++;
		}
	}
///////////////////////////////////////////////////
int main(void)
{	
		sei();
		TIMSK=0x04;
		lcd_init();
	
	while(1)
	{
	TIMSK = (1<<TOIE1); // Timer(s)/Counter(s) Interrupt(s) initialization

	TCCR1B = 0x70;/* start timer1 with external pulses (T1 rising edge) */
	_delay_ms(1000);
	TCCR1B = 0x00; //stop timer1
	TIMSK= 0x00; //disable interrupt
	dur= TCNT1; /* store the number of counts in TCNT1 register */
	freq = dur + i*65536; /* calculate the frequency */
	TCNT1=0x0000;/* clear TCNT1 register for the next reading */
	i=0;/* clear number of overflows in one second for the next reading */
	lcd_init();// LCD module initialization
	//////////////////// display ////////////////////////
	lcd_gotoxy(1,1);
	lcdprint("freq");
	lcd_gotoxy(1,2);
if(freq>=1000000) /* if frequency more than or equal 1Mhz use "Mhz" on lcd */
{
	freqf1=freq/1000000; //divide by 1Mhz scale
	freqf=freqf1;
	sprintf(mystr, "%f", freqf);
	lcdprint(mystr);
	lcdprint("MHZ");

} 
else if(freq>=1000) /* if frequency more than or equal 1Mhz use "Mhz" on lcd */
{
	freqf1=freq/1000; //divide by 1Mhz scale
	freqf=freqf1;	//float to double
	sprintf(mystr, "%f", freqf); //convert double to char 
	lcdprint(mystr);
	lcdprint("kHZ");
}
else 
{  freqf=freq;
	sprintf(mystr, "%f", freqf);
	lcdprint(mystr);
	lcdprint("Hz");	

}
}return 0;
}



		

		
